/***************************************************************************
    file	         : kb_cookie.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"kb_cookie.h"

/*  KBCookieJar								*/
/*  setCookie	: Set a cookie						*/
/*  cookie	: cchar *	: Cookie name				*/
/*  value	: cchar *	: Cookie value				*/
/*  (returns)	: void		:					*/

void	KBCookieJar::setCookie
	(	cchar 		*cookie,
		cchar		*value
	)
{
	fprintf
	(	stderr,
		"KBCookieJar::setCookie: [%s]<-[%s]\n",
		cookie,
		value
	)	;
	m_cookies.replace (cookie, new QCString(value)) ;
}

/*  KBCookieJar								*/
/*  getCookie	: Get a cookie						*/
/*  cookie	: cchar *	: Cookie name				*/
/*  (returns)	: cchar *	: Cookie value or null on error		*/

cchar	*KBCookieJar::getCookie
	(	cchar 		*cookie
	)
{
	const QCString *value = m_cookies.find(cookie)	;

	fprintf
	(	stderr,
		"KBCookieJar::getCookie: [%s]->[%s]\n",
		cookie,
		value == 0 ? "/NONE/" : value->data()
	)	;

	return	value == 0 ? 0 : value->data()		;
}

KBCookieJar
	*KBCookieJar::self  ()
{
	static KBCookieJar *jar = 0 ;
	if (jar == 0) jar = new KBCookieJar ;
	return	jar ;
}


