/***************************************************************************
    file	         : kb_fixedlabel.cpp
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qfont.h>
#include	<qfontmetrics.h>

#include	"kb_fixedlabel.h"

#define		EXTRA	(15)


KBFixedLabel::KBFixedLabel
	(	uint		width,
		QWidget		*parent
		
	)
	:
	QLabel	(parent)
{
//	fprintf
//	(	stderr,
//		"KBFixedLabel::KBFixedLabel: [%d]->[%d]\n",
//		width,
//		QFontMetrics(QFont()).width("123456789") * width / 10
//	)	;
	setFixedWidth (QFontMetrics(QFont()).width("123456789") * width / 10 + EXTRA) ;
}

KBFixedLabel::KBFixedLabel
	(	const QString	&text,
		QWidget		*parent
	)
	:
	QLabel	(text, parent)
{
//	fprintf
//	(	stderr,
//		"KBFixedLabel::KBFixedLabel: [%s]->[%d]\n",
//		(const char *)text,
//		QFontMetrics(QFont()).width(text)
//	)	;
	setFixedWidth (QFontMetrics(QFont()).width(text) + EXTRA) ;
}

KBFixedLabel::KBFixedLabel
	(	const QStringList	&text,
		QWidget			*parent
	)
	:
	QLabel	(text[0], parent)
{
//	fprintf
//	(	stderr,
//		"KBFixedLabel::KBFixedLabel: [%s]->[%d]\n",
//		(const char *)text,
//		QFontMetrics(QFont()).width(text)
//	)	;
	int	maxw	= 0 ;
	for (uint idx = 0 ; idx < text.count() ; idx += 1)
	{	int w = QFontMetrics(QFont()).width(text[idx]) ;
		if (w > maxw) maxw = w ;
	}
	setFixedWidth (maxw + EXTRA) ;
}

