/***************************************************************************
    file	         : kb_qtchoice.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_QTLISTBOX_H
#define	__KB_QTLISTBOX_H


#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"
#include	"kb_combobox.h"

#include	"libkbase_exports.h"

#define	LISTBOX_NOCHANGE(s)	\
	{	m_inSetValue = true  ;	\
		s ;			\
		m_inSetValue = false ;	\
	}


class	KBListBox	;

/*  KBCtrlListBox							*/
/*  ------------							*/
/*  Wrapper class for choice combo box control				*/

class	LIBKBASE_API	KBCtrlListBox : public RKListBox, public KBControl
{
	Q_OBJECT

	KBListBox	*m_listbox	;
	bool		m_inSetValue	;

private slots :

	void		slotChanged	() ;

protected :

        virtual void    giveFocus     	() ;

public	:

	KBCtrlListBox 	(KBDisplay *, KBListBox *, uint) ;
virtual~KBCtrlListBox 	() ;

	virtual	void	showName	() ;
	virtual	void	setupProperties	() ;
	virtual	void	setData		(void *) ;
	virtual	void	showAs		(KB::ShowAs) ;
	virtual	void	setValue   	(const KBValue &) ;
	virtual	KBValue	getValue   	() ;
	virtual	void	clearValue	(bool) ;
	virtual	bool	changed    	() ;
	virtual	bool	isEmpty		() ;
	virtual	bool	isValid		(bool) ;

	SETFOCUS
//	SIZEHINT
}	;

#endif	// __KB_QTLISTBOX_H
