/***************************************************************************
    file	         : kb_memo.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	_KB_MEMO_H
#define	_KB_MEMO_H

#include	"libkbase_exports.h"


#include	"kb_classes.h"
#include	"kb_item.h"
#include	"kb_attrframe.h"



/*  KBMemo								*/
/*  ------								*/
/*  This class is used to represent a memo field in forms and reports	*/
/*  (ie., a multiple line edit box).					*/

class LIBKBASE_API	KBMemo : public KBItem
{
	Q_OBJECT

	KBAttrStr	m_fgcolor   ;	/* Foreground (text) colour	*/
	KBAttrStr	m_bgcolor   ;	/* Background colour		*/
	KBAttrFrame	m_frame	    ;	/* Frame style			*/
	KBAttrStr	m_font	    ; 	/* Report font			*/
	KBAttrBool	m_nullOK    ;	/* Is empty field OK		*/
	KBAttrStr	m_hilite    ;	/* Text highlight scheme	*/
	KBAttrBool	m_wrap	    ;	/* Text wrapping		*/
	KBAttrBool	m_emptyNull ;	/* Treat empty fields as null	*/
	KBEvent		m_onChange  ;

	KBReport	*m_report   ;

	bool			doCheckValid	(const QString &, bool) ;

protected :

	virtual	KBControl	*makeCtrl	(uint)	  ;

public	:

	KBMemo	(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBMemo	(KBNode  *, KBMemo *) ;
virtual~KBMemo	() ;

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar *) ;
#endif
	virtual	KBNode		*replicate	(KBNode *) ;
	virtual	KBValue		getValue	(uint)	   ;

	bool			checkValid	(const QString &, bool) ;
	void			userChange	(uint)	   ;

	inline	bool	isWrapping ()
	{
		return	m_wrap.getBoolValue() ;
	}
}	;



#if	! __KB_RUNTIME
extern LIBKBASE_API	bool	memoPropDlg
			(	KBMemo			*,
				cchar			*,
				QPtrList<KBAttr>	&,
				cchar			* = 0
			)	;
#endif
#endif	// _KB_MEMO_H
