/***************************************************************************
    file	         : kb_qtbutton.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTBUTTON_H
#define	_KB_QTBUTTON_H


#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"rk_pushbutton.h"

#include	"libkbase_exports.h"


/*  KBCtrlButton								*/
/*  ------------							*/
/*  Wrapper class for push button controls				*/

class	LIBKBASE_API	KBCtrlButton : public RKPushButton, public KBControl
{
	KBButton	*m_button	;
	QPixmap		m_pm1		;
	QPixmap		m_pm2		;

protected :

        virtual void    giveFocus	() ;
	virtual	bool	eventFilter	(QObject *, QEvent *)	;

public	:

	virtual	void	setValue 	(const KBValue &) ;
	virtual	KBValue	getValue	()			;
	virtual	bool	write	 	(KBWriter *, QRect, const KBValue &, bool, int &) ;

	void		setPixmaps	(const QPixmap &, const QPixmap &) ;

	KBCtrlButton (KBDisplay *, KBButton *) ;
virtual~KBCtrlButton () ;

	SETFOCUS
//	SIZEHINT
}	;

#endif	// _KB_QTBUTTON_H
