/***************************************************************************
    file	         : kb_qtfield.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTFIELD_H
#define	_KB_QTFIELD_H


#include	"kb_ctrl.h"
#include	"kb_mask.h"

#include	"rk_hbox.h"

#include	"libkbase_exports.h"

#define	FIELD_NOCHANGE(s)	\
	{	m_inSetValue = true  ;	\
		s ;			\
		m_inSetValue = false ;	\
	}

class	QHBoxLayout	;
class	RKPushButton	;
class	RKLineEdit	;

/*  KBCtrlField								*/
/*  -----------								*/
/*  Wrapper class for line edit control					*/

/*  To allow the helper button to appear and disappear without the	*/
/*  layout changing, particularly in a dynamic layout, the QLineEdit	*/
/*  is placed inside an RKHBox along with the helper button, which can	*/
/*  be shown/hidden as needed; the RKHBox layout will then do the work.	*/
/*  However, this means that we must proxy the QLineEdit's sizeHint and	*/
/*  sizePolicy methods, and set the QLineEdit itself's size policy to	*/
/*  Preferred/Preferred.						*/

class	LIBKBASE_API	KBCtrlField : public RKHBox, public KBControl
{
	Q_OBJECT

	KBField		*m_field	;
	RKLineEdit	*m_lEdit	;
	RKPushButton	*m_bHelp	;
	KBMaskedInput	*m_inputMask	;
	bool		m_inSetValue	;

private slots :

	void		helpClicked 	() ;
	void		textChangedTo	(const QString &) ;
	void		returnPressed	() ;

protected :

        virtual void    giveFocus	() ;
	virtual bool	eventFilter	(QObject *, QEvent *) ;

public	:

	KBCtrlField (KBDisplay *, KBField *, uint) ;
virtual~KBCtrlField () ;

	virtual	void		showName	()	;
	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setupProperties	()	;
	virtual	void		setValue	(const KBValue &) ;
	virtual	KBValue		getValue	()	;
	virtual	void		clearValue	(bool)	;
	virtual	bool		changed		()	;
	virtual	bool		isEmpty		()	;
	virtual	bool		isValid		(bool)	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	virtual	QString		morphText	() 	;

	virtual	QWidget		*mainWidget	() ;
	virtual	QSize		sizeHint	() const	;
	virtual	QSizePolicy	sizePolicy	() const	;

	SETFOCUS
}	;


#endif	// _KB_QTFIELD_H
