/***************************************************************************
    file	         : kb_qtlabel.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB__QTLABEL_H
#define	_KB__QTLABEL_H

#include	<qlabel.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"libkbase_exports.h"

/*  KBCtrlLabel								*/
/*  -----------								*/
/*  Wrapper class for label controls					*/

class	LIBKBASE_API	KBCtrlLabel : public QLabel, public KBControl
{
	Q_OBJECT

	KBLabel		*m_label	;

protected slots :

	void		backgroundChanged()	;

protected :

        virtual void    giveFocus	() {}	;

public	:

	KBCtrlLabel (KBDisplay *, KBLabel *) ;
       ~KBCtrlLabel () ;

	virtual	void	showAs			(KB::ShowAs)	  ;
	virtual	void	setupProperties		()		  ;
	virtual	void	setValue 		(const KBValue &) ;
	virtual	KBValue	getValue		()		  ;
	virtual	bool	write			(KBWriter *, QRect, const KBValue &, bool, int &) ;

	virtual	void	mouseReleaseEvent	(QMouseEvent *)	  ;

	SETFOCUS
//	SIZEHINT
}	;

#endif	// _KB__QTLABEL_H
