/***************************************************************************
    file	         : kb_qtmemo.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	_KB_QTMEMO_H
#define	_KB_QTMEMO_H


#include	"kb_ctrl.h"
#include	"kb_textedit.h"


#include	"libkbase_exports.h"

class		KBMemo			;
class		KBCtrlMemo		;
class		KBSyntaxHighlighter	;

#define	MEMO_NOCHANGE(s)	\
	{	m_inSetValue = true  ;	\
		s ;			\
		m_inSetValue = false ;	\
	}

/*  ------------------------------------------------------------------  */

/*  KBCtrlMemo								*/
/*  ----------								*/
/*  Wrapper class for memi edit control					*/

class	LIBKBASE_API	KBCtrlMemo : public KBTextEdit, public KBControl
{
	Q_OBJECT

	KBMemo			*m_memo		;
	KBValue			m_iniVal	;
	KBSyntaxHighlighter	*m_highlighter	;

	bool			m_modified	;
	bool			m_inSetValue	;
	QString			m_curHilite	;

	void			setHilite	()	;

protected	:

	virtual	bool		notifyFilter	(QObject *, QEvent *) ;
	virtual bool		eventFilter	(QObject *, QEvent *) ;
	virtual	QPopupMenu	*createPopupMenu(const QPoint &) ;

protected slots :

        virtual void    	giveFocus	() 	;
	void			loadFromFile	()	;
	void			saveToFile	()	;
	void			editChanged	()	;

public	:

		KBCtrlMemo	(KBDisplay *, KBMemo *, uint) ;
	virtual~KBCtrlMemo	() ;

	virtual	void		showName	()	;
	virtual	void		setupProperties	()	;
	virtual	void		setPalette	(const QPalette *)	;
	virtual	void		setFont		(const QFont    *)	;
	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setValue	(const KBValue &) ;
	virtual	KBValue		getValue	()	;
	virtual	void		clearValue	(bool)	;
	virtual	bool		changed		()	;
	virtual	bool		isEmpty		()	;
	virtual	bool		isValid		(bool)	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	virtual	bool		viewSetFocusOK	()	;

	virtual	QWidget		*mainWidget	()	;

	SETFOCUS
//	SIZEHINT
}	;


#endif	// _KB_QTMEMO_H
