/***************************************************************************
    file	         : kb_qtrichtext.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	_KB_QTRICHTEXT_H
#define	_KB_QTRICHTEXT_H

#include	<qtextbrowser.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"
#include	"libkbase_exports.h"


class	LIBKBASE_API	KBRichText	;

/*  KBCtrlRichtext							*/
/*  --------------							*/
/*  Wrapper class for rich text control					*/

class	KBCtrlRichText : public QTextBrowser, public KBControl
{
	Q_OBJECT

	KBRichText		*m_richText	;

	virtual	void		emitLinkClicked	(const QString &) ;

protected :

	virtual	bool		notifyFilter	(QObject *, QEvent *) ;
	virtual	void		giveFocus	() ;

public	:

	KBCtrlRichText (KBDisplay *, KBRichText *, uint) ;
virtual~KBCtrlRichText () ;

	virtual	void	showName	() 	;
	virtual	void	showAs		(KB::ShowAs) ;
	virtual	void	setupProperties	()	;
	virtual	void	setValue	(const KBValue &) ;
	virtual	KBValue	getValue	()	;
	virtual	void	clearValue	(bool)	;
	virtual	bool	changed		()	;
	virtual	bool	isEmpty		()	;
	virtual	bool	write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	virtual	QWidget	*mainWidget	()	;
	SETFOCUS
//	SIZEHINT
}	;


#endif	// _KB_QTRICHTEXT_H
