/***************************************************************************
    file	         : kb_tree.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_TREE_H
#define	_KB_TREE_H

#include	"libkbase_exports.h"

#include	<qdict.h>
#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_linktree.h"

/*  KBTree								*/
/*  ----------								*/
/*  This class is used to represent a tree element. This is vartually	*/
/*  the same as a link, differing in the display.			*/

class	LIBKBASE_API	KBTree : public KBLinkTree
{
	Q_OBJECT

	KBAttrStr	m_group		;
	KBAttrBool	m_clickOpen	;
	KBAttrBool	m_setClose	;
	KBAttrInt	m_treeType	;
	uint		m_groupCount	;

protected :

	virtual	uint		addDummyItems 	() ;
	virtual	KBControl	*makeCtrl    	(uint)	;

public	:

	KBTree	(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBTree	(KBNode  *, KBTree *) ;

virtual~KBTree	()		 ;

#if	! __KB_RUNTIME
	virtual	bool	propertyDlg  	(cchar  *) ;
#endif
	virtual	KBNode	*replicate	(KBNode *) ;

	inline	uint	groupCount	()
	{
		return	m_groupCount	;
	}
	inline	bool	clickOpen	()
	{
		return	m_clickOpen.getBoolValue() ;
	}
	inline	bool	setClose	()
	{
		return	m_setClose .getBoolValue() ;
	}
	inline	int	treeType	()
	{
		return	m_treeType .getIntValue	() ;
	}

	virtual void		setUserFilter	(uint, const QString	&) ;
	virtual void		setUserSorting	(uint, const QString	&) ;
	virtual	void		reload		(uint) ;
	virtual	KBValue		getExtra	(uint, bool, uint) ;

	static	KBPopupMenu	*makeTreePopup
				(	QWidget		*,
					QObject		*,
					Qt::ButtonState	*,
					NodeSpec	**
				)	;
}	;

extern	LIBKBASE_API	bool	treePropDlg (KBLink *, cchar *, QPtrList<KBAttr> &) ;

#endif	// _KB_TREE_H
