/***************************************************************************
    file	         : kb_cookiehar.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<stdio.h>

#include	<kjs/global.h>
#include	<kjs/interpreter.h>
#include	<kjs/lookup.h>
#include	<kjs/object.h>
#include	<kjs/operations.h>
#include	<kjs/types.h>
#include	<kjs/ustring.h>
#include	<kjs/value.h>

#include	"kb_classes.h"
#include	"kb_prompt.h"
#include	"kb_cookiejar.h"
#include	"kb_cookiejar.lut"
#include	"kb_kjsscript.h"
#include	"kb_cookie.h"


using	namespace	KJS	;



extern	void	displayAllProperties
		(	KJS::Interpreter	*,
			KJS::Object		&
		)	;

const	ClassInfo	RekallCookieJarObjectImp::info =
			{
				"RekallCookieJar",
				0,
				&RekallCookieJarTable,
				0
			}	;

#if	0
@begin RekallCookieJarTable 21
  getCookie     RekallCookieJarObjectImp::getCookie		DontEnum|Function 2
  setCookie     RekallCookieJarObjectImp::setCookie		DontEnum|Function 1
@end
#endif


/*  ------------------------------------------------------------------	*/

RekallCookieJarObjectImp::RekallCookieJarObjectImp
	(	ExecState		*,
		ObjectPrototypeImp	*objProto
	)
	:
	ObjectImp (Object(objProto))
{
	fprintf
	(	stderr,
		"RekallCookieJarObjectImp::RekallCookieJarObjectImp: called\n"
	)	;
}


Value	RekallCookieJarObjectImp::get
	(	ExecState	 *exec,
		const Identifier &propertyName
	)
	const
{
	fprintf
	(	stderr,
		"RekallCookieJarObjectImp::get\n"
	)	;

	return	lookupGet<RekallCookieJarFunctionImp, RekallCookieJarObjectImp, ObjectImp>
			 (	exec,
				propertyName,
				&RekallCookieJarTable,
				this
			 )	;
}


Value	RekallCookieJarObjectImp::getValueProperty
	(	ExecState	*,
		int		token
	)
	const
{
	switch (token)
	{
		default	:
			break	;
	}

	return	Number(-1)	;
}


RekallCookieJarFunctionImp::RekallCookieJarFunctionImp
	(	ExecState	*exec,
		int		id,
		int		length
	)
	:
	InternalFunctionImp
	(
		(FunctionPrototypeImp*)(exec->interpreter()->builtinFunctionPrototype().imp())
	),
	m_id	(id)
{
	fprintf
	(	stderr,
		"RekallCookieJarFunctionImp::RekallCookieJarFunctionImp: called\n"
	)	;

	Value	protect (this) ;
	put	(exec, "length", Number(length), DontDelete|ReadOnly|DontEnum) ;
}

bool	RekallCookieJarFunctionImp::implementsCall () const
{
	return	true	;
}

Value	RekallCookieJarFunctionImp::call
	(	ExecState	*exec,
		Object		&,
		const List	&args
	)
{
	fprintf
	(	stderr,
		"RekallCookieJarFunctionImp::call: m_id=%d\n",
		m_id
	)	;

	switch (m_id)
	{
		case RekallCookieJarObjectImp::setCookie :
			KBCookieJar::self()->setCookie
			(	kjsStringArg(exec, args, 0).latin1(),
				kjsStringArg(exec, args, 1).latin1()
			)	;
			return	Number (0) ;


		case RekallCookieJarObjectImp::getCookie:
			{
			cchar	*value	= KBCookieJar::self()->getCookie
					  (	kjsStringArg(exec, args, 0).latin1()
					  )	;
			if (value != 0)
				return	KJS::String (QString(value)) ;
			}
			return	KJS::Null () ;

		default	:
			break	;
	}

	return	Number(-1) ;
}
