/***************************************************************************
    file	         : kb_formproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FORMPROXY_H
#define	__KB_FORMPROXY_H


class	KBKJSInterpreter	;

/*  KBFormProxy								*/
/*  ------------							*/
/*  Proxy class for Rekall forms ....					*/

class	KBFormProxy : public KBBlockProxy
{
protected :

	KBForm			*m_form 	;

public	:

	KBFormProxy	(KBKJSInterpreter *, KBForm *) ;
	~KBFormProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	class MethodImp : public KBBlockProxy::MethodImp
	{
	protected :

		const KBFormProxy	*m_form	;

	public	:

		MethodImp	(KBMethodSpec *, const KBFormProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_openForm	   = IDB_FORM +  1 ;
		static	const uint	id_openReport	   = IDB_FORM +  2 ;
		static	const uint	id_close	   = IDB_FORM +  3 ;
		static	const uint	id_getOpener	   = IDB_FORM +  4 ;
		static	const uint	id_getParameter	   = IDB_FORM +  5 ;
		static	const uint	id_showMessage	   = IDB_FORM +  6 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_FORMPROXY_H
