/***************************************************************************
    file	         : kb_linktreeproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_LINKTREEPROXY_H
#define	__KB_LINKTREEPROXY_H



/*  KBLinkTreeProxy							*/
/*  -------------							*/
/*  Proxy class for Rekall labels.					*/

class	KBLinkTreeProxy : public KBItemProxy
{
protected :

	KBLinkTree		*m_linktree	;

public	:

	KBLinkTreeProxy	(KBKJSInterpreter *, KBLinkTree *) ;
	~KBLinkTreeProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBItemProxy::MethodImp
	{
	protected :

		const KBLinkTreeProxy	*m_linktree	;

	public	:

		MethodImp	(KBMethodSpec *, const KBLinkTreeProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_getExtra	  = IDB_LINKTREE  + 1 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_LINKTREEPROXY_H
