/***************************************************************************
    file	         : kb_pysupport.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	<qstring.h>
#include	<qdict.h>

#include	"kb_python.h"
#include	"kb_pyvalue.h"


bool	pyDictToQtDict
	(	PyObject	*pyDict,
		QDict<QString>	&kbDict
	)
{
	PyObject	*key	;
	PyObject	*value	;
	int		pos	= 0 ;

	kbDict.setAutoDelete (true) ;

	if (pyDict != 0)
		while (PyDict_Next (pyDict, &pos, &key, &value))
		{
			bool	error;
			QString qKey = kb_pyStringToQString(key, error);
			if (error) return false;
			QString qValue = kb_pyStringToQString(value, error);
			if (error) return false;
			kbDict.insert(qKey, new QString(qValue));
		}
	return true;
}

PyObject
	*qtDictToPyDict
	(	QDict<QString>	&kbDict
	)
{
	PyObject		*pyDict	= PyDict_New() ;
	QString			*res	;
	QDictIterator<QString>	iter	(kbDict) ;
	
	if (pyDict == 0)
		return 0;

	while ((res = iter.current()) != 0)
	{
		QString	v = *res ;
		if (v.isNull()) v = "" ;

		PyObject *pyKey = kb_qStringToPyString(iter.currentKey());
		if (pyKey == 0)
		{
			Py_DECREF(pyDict);
			return 0;
		}

		PyObject *pyValue = kb_qStringToPyString(v);
		if (pyValue == 0)
		{
			Py_DECREF(pyKey);
			Py_DECREF(pyDict);
			return 0;
		}

		int rc = PyDict_SetItem (pyDict, pyKey, pyValue);
		Py_DECREF(pyKey);
		Py_DECREF(pyValue);

		if (rc == -1)
		{
			Py_DECREF(pyDict);
			return 0;
		}
		
		iter	+= 1 ;
	}

	return	pyDict	;
}
